// ResultDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "ResultDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CCrystalMarkDlg* Dlg;

/////////////////////////////////////////////////////////////////////////////
// CResultDlg _CAO


CResultDlg::CResultDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResultDlg::IDD, pParent)
{
	Dlg = (CCrystalMarkDlg*)pParent;

	//{{AFX_DATA_INIT(CResultDlg)
	m_ChipSet = _T("");
	m_CpuClock = _T("");
	m_CpuName = _T("");
	m_Hdd = _T("");
	m_HddSize = _T("");
	m_Memory = _T("");
	m_MemorySize = _T("");
	m_OS = _T("");
	m_Video = _T("");
	m_MotherBoard = _T("");
	m_VideoSize = _T("");
	m_DisplayMode = _T("");
	m_FontSmoothing = _T("");
	m_StaticHddRaid = _T("");
	m_DirectX = _T("");
	//}}AFX_DATA_INIT
}


void CResultDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResultDlg)
	DDX_Control(pDX, IDC_RESULT_MMT_SCORE, m_MMTScoreC);
	DDX_Control(pDX, IDC_RESULT_MEM_SCORE, m_MEMScoreC);
	DDX_Control(pDX, IDC_RESULT_OGL_SCORE, m_OGLScoreC);
	DDX_Control(pDX, IDC_RESULT_NET_SCORE, m_NETScoreC);
	DDX_Control(pDX, IDC_RESULT_MARK_SCORE, m_MarkScoreC);
	DDX_Control(pDX, IDC_RESULT_HDD_SCORE, m_HDDScoreC);
	DDX_Control(pDX, IDC_RESULT_GDI_SCORE, m_GDIScoreC);
	DDX_Control(pDX, IDC_RESULT_FPU_SCORE, m_FPUScoreC);
	DDX_Control(pDX, IDC_RESULT_D3D_SCORE, m_D3DScoreC);
	DDX_Control(pDX, IDC_RESULT_D2D_SCORE, m_D2DScoreC);
	DDX_Control(pDX, IDC_RESULT_ALU_SCORE, m_ALUScoreC);
	DDX_Text(pDX, IDC_RESULT_CHIP_SET, m_ChipSet);
	DDX_Text(pDX, IDC_RESULT_CPU_CLOCK, m_CpuClock);
	DDX_Text(pDX, IDC_RESULT_CPU_NAME, m_CpuName);
	DDX_Text(pDX, IDC_RESULT_HDD, m_Hdd);
	DDX_Text(pDX, IDC_RESULT_HDD_SIZE, m_HddSize);
	DDX_Text(pDX, IDC_RESULT_MEMORY, m_Memory);
	DDX_Text(pDX, IDC_RESULT_MEMORY_SIZE, m_MemorySize);
	DDX_Text(pDX, IDC_RESULT_OS, m_OS);
	DDX_Text(pDX, IDC_RESULT_VIDEO, m_Video);
	DDX_Text(pDX, IDC_RESULT_MOTHER_BOARD, m_MotherBoard);
	DDX_Text(pDX, IDC_RESULT_VIDEO_SIZE, m_VideoSize);
	DDX_Text(pDX, IDC_RESULT_DISPLAY_MODE, m_DisplayMode);
	DDX_Text(pDX, IDC_RESULT_FONT_SMOOTHING, m_FontSmoothing);
	DDX_Text(pDX, IDC_STATIC_HDD_RAID, m_StaticHddRaid);
	DDX_Text(pDX, IDC_RESULT_DIRECT_X, m_DirectX);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CResultDlg, CDialog)
	//{{AFX_MSG_MAP(CResultDlg)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResultDlg bZ[W nh

BOOL CResultDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(Dlg->m_hIcon, TRUE);

	m_EnableAlpha = FALSE;
	CString cstr;

	Dlg->m_RankingDlg->UpdateData(TRUE);

	if( Dlg->m_RankingDlg->m_RaidOn == 1 )
	{
		m_StaticHddRaid = "RAID";
	}else{
		m_StaticHddRaid = "HDD";
	}

	char str[256];
	GetPrivateProfileString("Setting","EnableAlpha","0",str,256,Dlg->m_ini);
	if(atoi(str) > 0){
		GetPrivateProfileString("Setting","Alpha","255",str,256,Dlg->m_ini);
		SetAlphaWindow(m_hWnd,atoi(str));
		m_EnableAlpha = TRUE;
	}

	m_OS = Dlg->m_SystemDlg->m_SysOSCaption;
	m_OS += Dlg->m_SystemDlg->m_SysOSCSDVersion;
	m_OS.TrimLeft();
	m_ChipSet = Dlg->m_RankingDlg->m_ChipSetNameUser;
	m_MotherBoard = Dlg->m_RankingDlg->m_MotherBoardUser;
	m_Video = Dlg->m_RankingDlg->m_VideoNameUser;
	m_Memory = Dlg->m_RankingDlg->m_MemoryUser;
	if( Dlg->m_RankingDlg->m_RaidOn ){
		m_Hdd = Dlg->m_RankingDlg->m_RaidController;
		m_HddSize = Dlg->m_RankingDlg->m_RaidSize;
	}else{
		m_Hdd = Dlg->m_RankingDlg->m_DiskNameUser;
		m_HddSize = Dlg->m_RankingDlg->m_DiskSizeUser;
	}
	m_VideoSize = Dlg->m_RankingDlg->m_VideoSizeUser;
	m_MemorySize = Dlg->m_RankingDlg->m_MemorySizeUser;

	m_CpuName = Dlg->m_RankingDlg->m_CPUNameUser;
	if(Dlg->m_RankingDlg->m_SystemClockUser.IsEmpty()
	|| Dlg->m_RankingDlg->m_MultiplierUser.IsEmpty() )
	{
		m_CpuClock.Format("%s MHz x %s",
			Dlg->m_RankingDlg->m_ClockUser,
			Dlg->m_CPUDlg->m_CPUNumber);
	}else{
		m_CpuClock.Format("%s MHz x %s (%sx%s)",
			Dlg->m_RankingDlg->m_ClockUser,
			Dlg->m_CPUDlg->m_CPUNumber,
			Dlg->m_RankingDlg->m_SystemClockUser,
			Dlg->m_RankingDlg->m_MultiplierUser);
	}
	if( Dlg->m_MarkDlg->m_FlagEntry ){
		m_CpuClock += " [ " + Dlg->m_MarkDlg->BenchSetting.ProcessorMask + " ]";
	}
	m_DisplayMode = Dlg->m_MarkDlg->BenchSetting.DisplayMode;
	m_FontSmoothing = Dlg->m_MarkDlg->BenchSetting.FontSmoothing;
	m_DirectX = Dlg->m_DeviceDlg->m_DeviceDirectXVersion;

	Dlg->GetWindowText(cstr);
	SetWindowText(cstr);

// Score
	m_Mater[0] = &m_MarkScoreC;
	m_Mater[1] = &m_ALUScoreC;
	m_Mater[2] = &m_FPUScoreC;
	m_Mater[3] = &m_MEMScoreC;
	m_Mater[4] = &m_HDDScoreC;
	m_Mater[5] = &m_MMTScoreC;
	m_Mater[6] = &m_GDIScoreC;
	m_Mater[7] = &m_D2DScoreC;
	m_Mater[8] = &m_D3DScoreC;
	m_Mater[9] = &m_OGLScoreC;
	m_Mater[10]= &m_NETScoreC;

	m_Mater[0]->SetMaxWidth(100000);
	m_Mater[0]->SetWidth(Dlg->m_MarkDlg->R[0][0]);
	int i;
	if( Dlg->m_MarkDlg->m_FlagEntry ){
		for(i=0;i<=10;i++){
			m_Mater[i]->SetFontColor(RGB(128,128,255),RGB(128,128,255),RGB(128,128,255),RGB(64,64,255));
			m_Mater[i]->SetMaterColor(RGB(240,240,255));
		}
	}else{
		for(i=0;i<=10;i++){
			m_Mater[i]->SetFontColor(RGB(128,128,128),RGB(128,128,128),RGB(128,128,128),RGB(64,64,64));
			m_Mater[i]->SetMaterColor(RGB(240,240,240));
		}
	}

	for(i=1;i<=10;i++)
	{
		m_Mater[i]->SetFontSize(190);
		m_Mater[i]->SetMaxWidth(20000);
		m_Mater[i]->SetWidth(Dlg->m_MarkDlg->R[0][i]);
	}
	
	cstr.Format("%.2f MB/s",( Dlg->m_MarkDlg->V[3][0] + Dlg->m_MarkDlg->V[3][1] + Dlg->m_MarkDlg->V[3][2] ) / 300.0 );
	m_Mater[5]->SetWidth( (int)(atof(cstr) * 10) );
	m_Mater[5]->SetString( cstr );
	m_Mater[5]->SetMaxWidth(40000);
	cstr.Format("%.2f MB/s",( Dlg->m_MarkDlg->V[4][0] + Dlg->m_MarkDlg->V[4][1] ) / 200.0 );
	m_Mater[10]->SetWidth( (int)(atof(cstr) * 100) );
	m_Mater[10]->SetString(cstr);

	UpdateData(FALSE);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CResultDlg::OnOK() 
{
	CDialog::OnOK();
}

void CResultDlg::OnCancel() 
{	
	CDialog::OnCancel();
}

HBRUSH CResultDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}
