#include "stdafx.h"
#include <windows.h>
#include <winsock.h>
#include <string.h>
#include "SockLib.h"

#pragma comment(lib,"WSOCK32.lib")

// WSADATA\̂̒`
static WSADATA g_wsaData;

// WinSock̏
int SocketInit()
{
	WORD wVersionRequested = MAKEWORD(1,1);	// WINSOCK Version 1.1 w
	int nErr = WSAStartup(wVersionRequested,&g_wsaData);
	if (nErr != 0) {
		return WSAGetLastError();
	}
	return 0;
}

// WinSock̏I
int SocketCleanup()
{
	int nErr = WSACleanup();
	if (nErr != 0) {
		return WSAGetLastError();
	}
	return 0;
}

// HOST̎擾
int SocketGetHostname(char* pszHostname,const int nNameSize)
{
	int nErr = gethostname(pszHostname,nNameSize);
	if (nErr != 0)
		return WSAGetLastError();
	return 0;
}

// IPAhX̎擾
long SocketGetIPaddress(const char* pszHostName, char* pszIPAddress)
{
	IN_ADDR in;
	PHOSTENT pHostent = gethostbyname(pszHostName);
	if (pHostent == NULL) {
		return WSAGetLastError();
	}
	memcpy(&in,pHostent->h_addr,4);
	lstrcpy(pszIPAddress,inet_ntoa(in));
	return 0;
}

// zXg̎擾
char* GetHostname()
{
	static char szHostname[HOSTNAME_SIZE] = "";

	int nResult = SocketInit();
	if (!nResult)
		nResult = SocketGetHostname(szHostname,HOSTNAME_SIZE);
	if (nResult)
		*szHostname = '\0';
	SocketCleanup();
	return szHostname;
}

// IPAhX̎擾
char* GetIPaddress()
{
	static char szIPaddress[IPADDRESS_SIZE] = "";
	char szHostname[HOSTNAME_SIZE];

	int nResult = SocketInit();
	if (!nResult) {
		nResult = SocketGetHostname(szHostname,HOSTNAME_SIZE);
		if (!nResult) {
			nResult = SocketGetIPaddress(szHostname,szIPaddress);
		}
	}
	if (nResult)
		*szIPaddress = '\0';
	SocketCleanup();
	return szIPaddress;
}